/*
 * SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
 *
 * Copyright (C) 2018 Philippe Gerum  <rpm@xenomai.org>
 */

#ifndef _EVL_UAPI_CONTROL_ABI_H
#define _EVL_UAPI_CONTROL_ABI_H

#include <linux/types.h>

/* Earliest ABI level we support. */
#define EVL_ABI_BASE   36
/*
 * Current/latest ABI level we support. We may decouple the base and
 * current ABI levels by providing backward compatibility from the
 * latter to the former. CAUTION: a litteral value is required for the
 * current ABI definition (scripts reading this may be naive).
 */
#define EVL_ABI_LEVEL  36

#define EVL_CONTROL_DEV  "/dev/evl/control"

struct evl_core_info {
	__u32 abi_base;
	__u32 abi_current;
	__u32 fpu_features;
	__u64 shm_size;
};

struct evl_cpu_state {
	__u32 cpu;
	__u64 state_ptr;	/* (__u32 __user *state) */
};

#define EVL_CONTROL_IOCBASE	'C'

#define EVL_CTLIOC_GET_COREINFO		_IOR(EVL_CONTROL_IOCBASE, 0, struct evl_core_info)
#define EVL_CTLIOC_SCHEDCTL		_IOWR(EVL_CONTROL_IOCBASE, 1, struct evl_sched_ctlreq)
#define EVL_CTLIOC_GET_CPUSTATE		_IOR(EVL_CONTROL_IOCBASE, 2, struct evl_cpu_state)

#endif /* !_EVL_UAPI_CONTROL_ABI_H */
